const MBTiles = require('@mapbox/mbtiles');
const p = require("path");

// Enable CORS and set correct mime type/content encoding
let header = {
    "Access-Control-Allow-Origin":"*",
    "Access-Control-Allow-Headers":"Origin, X-Requested-With, Content-Type, Accept",
    "Content-Type":"application/x-protobuf",
    "Content-Encoding":"gzip"
};

// Route which handles requests like the following: /<mbtiles-name>/0/1/2.pbf
module.exports = function(app) {

    app.get('/:source/mbtiles/:z/:x/:y.pbf', function(req, res) {
        new MBTiles(p.join(__dirname, `/public/${req.params.source}.mbtiles`), function(err, mbtiles) {
            mbtiles.getTile(req.params.z, req.params.x, req.params.y, function(err, tile, headers) {
                if (err) {
                    res.set({"Content-Type": "text/plain"});
                    res.status(404).send('Tile rendering error: ' + err + '\n');
                } else {
                    res.set(header);
                    res.send(tile);
                }
            });
            if (err) console.log("error opening database");
        });
    });
}